import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:osam/osam.dart';

void main() {
  final t = TestState();
  runApp(MaterialApp(
    home: Container(
      color: Colors.greenAccent,
      alignment: Alignment.center,
      child: Test(
        t: t,
      ),
    ),
  ));
}

class Test extends StatefulWidget {
  final TestState t;

  const Test({Key key, this.t}) : super(key: key);

  @override
  _TestState createState() => _TestState();
}

class _TestState extends State<Test> {
  var isVisible = false;

  @override
  Widget build(BuildContext context) {
    return Center(
      child: Column(
        mainAxisAlignment: MainAxisAlignment.center,
        mainAxisSize: MainAxisSize.min,
        children: <Widget>[
//          if (isVisible)
          OsamBuilder(
            key: ValueKey('MyBuilder'),
            stream: widget.t.propertyStream((state) => state.num),
            builder: (ctx, snap) => Text(snap.toString()),
          ),
          RaisedButton(
            onPressed: () {
              widget.t.update((state) => state.num++);
            },
          ),
          RaisedButton(
            onPressed: () {
              setState(() {
                isVisible = !isVisible;
              });
            },
          )
        ],
      ),
    );
  }
}

class TestState extends BaseState<TestState> {
  var num = 0;

  TestState() : super();

  @override
  List<Object> get props => [num];
}
